#include <nspireio/nspireio.h>

int uart_getsn_AT(char* str, int num) {
    int i = 0;
    int max = num-1;
    for(int j = 1; j <= 10000000; j++) {
        while(uart_ready()) {
            if(i == max) {
                str[i] = 0;
                return 3;
            }
            char c = uart_getchar();
            str[i] = c;
            if(c == '\b') { i -= 2; }
            else {
               if(strncmp(str+i-7, "\r\n\r\nOK\r\n",8) == 0) {
                    str[i+1] =0;
                    return 1; // OK
                }
                else if(strncmp(str+i-10, "\r\n\r\nERROR\r\n",11) == 0) {
                    str[i+1] =0;
                    return 0; // ERROR
                }
            }
            i++;
        }
    }
    str[i] = 0;
    return 3; // UNKNOWN
}

int send_AT_command(char *cmd, int lg_buffer, char *buffer) {
  int ret;
//  nio_printf("Sending %s\n", cmd);
  uart_puts(cmd);
  ret = uart_getsn_AT(buffer,lg_buffer);
//  nio_printf("Response from esp8266 is : %s\n",buffer);
  return ret;
}

char** getNetworks(int *n, char *buffer) {
  int nbr = 0;
  char *tmp = buffer;
  char *start;
  char *end;
  int lg;

  while ((tmp = strstr(tmp, "+CWLAP:("))) {
    nbr++;
    tmp+=8;
  }
  char ** networks = malloc(nbr * sizeof(char*));

  start = buffer;
  for (int i=0; i<=nbr-1; i++) {
    start = strstr(start, ",\"") + 2;
    end = strstr(start, "\",") - 1;
    lg = end-start+1;
    networks[i] = (char*) malloc(lg+1);
    strncpy(networks[i], start, lg);
    *(networks[i]+lg) = '\0';
    start = strstr(start, ",\"") + 4;
  }

  *n = nbr;
  return networks;
}

void reset () {
  nio_printf("Reset dans 5 secondes...\n");
  msleep(5000);
  int volatile * const p_reg = (int *) 0x900A0008;
  *p_reg = 0x2;
}

// new_array[i] = malloc(strlen(array[i]+1)); then strcpy(new_array[i],array[i]);
